/*
 * Author: XueShuming
 *
 * Copyright (C) 2021 FMSoft <https://www.fmsoft.cn>
 *
 * This file is a part of PurC (short for Purring Cat), an HVML interpreter.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>
 */

 // NOTE
 // This file is auto-generated by using 'make-error-info.py'.
 // Please take care when you modify this file mannually.


static struct err_msg_info generic_err_msgs[] = {
    /* PURC_ERROR_OK */
    {
        "Ok",
        0,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_AGAIN */
    {
        "Try again",
        PURC_EXCEPT_AGAIN,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_BAD_SYSTEM_CALL */
    {
        "Bad system call",
        PURC_EXCEPT_OS_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_BAD_STDC_CALL */
    {
        "Bad STDC call",
        PURC_EXCEPT_OS_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_OUT_OF_MEMORY */
    {
        "Out of memory",
        PURC_EXCEPT_MEMORY_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_INVALID_VALUE */
    {
        "Invalid value",
        PURC_EXCEPT_INVALID_VALUE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_DUPLICATED */
    {
        "Duplicated",
        PURC_EXCEPT_INTERNAL_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NOT_IMPLEMENTED */
    {
        "Not implemented",
        PURC_EXCEPT_NOT_IMPLEMENTED,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NO_INSTANCE */
    {
        "No instance",
        PURC_EXCEPT_INTERNAL_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_TOO_LARGE_ENTITY */
    {
        "Tool large entity",
        PURC_EXCEPT_TOO_LARGE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_ENTITY_GONE */
    {
        "Entity gone",
        PURC_EXCEPT_ENTITY_GONE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_BAD_ENCODING */
    {
        "Bad encoding",
        PURC_EXCEPT_BAD_ENCODING,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NOT_SUPPORTED */
    {
        "Not supported",
        PURC_EXCEPT_UNSUPPORTED,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_OUTPUT */
    {
        "IO error encountered",
        PURC_EXCEPT_IO_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_TOO_SMALL_BUFF */
    {
        "Too small buffer",
        PURC_EXCEPT_INTERNAL_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_TOO_SMALL_SIZE */
    {
        "Too small size",
        PURC_EXCEPT_INTERNAL_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NULL_OBJECT */
    {
        "Null object",
        PURC_EXCEPT_INTERNAL_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_INCOMPLETE_OBJECT */
    {
        "Incomplete object",
        PURC_EXCEPT_INVALID_VALUE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NO_FREE_SLOT */
    {
        "No free slot",
        PURC_EXCEPT_MEMORY_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NOT_EXISTS */
    {
        "Does not exist",
        PURC_EXCEPT_ENTITY_NOT_FOUND,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_EXISTS */
    {
        "Entity exist",
        PURC_EXCEPT_ENTITY_EXISTS,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_ARGUMENT_MISSED */
    {
        "Argument missed",
        PURC_EXCEPT_ARGUMENT_MISSED,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_WRONG_DATA_TYPE */
    {
        "Wrong Data Type",
        PURC_EXCEPT_WRONG_DATA_TYPE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_WRONG_STAGE */
    {
        "Wrong stage",
        PURC_EXCEPT_BAD_TARGET_HTML,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_OVERFLOW */
    {
        "Overflow",
        PURC_EXCEPT_OVERFLOW,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_UNDERFLOW */
    {
        "Underflow",
        PURC_EXCEPT_UNDERFLOW,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_DIVBYZERO */
    {
        "Divide by zero",
        PURC_EXCEPT_ZERO_DIVISION,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_INVALID_FLOAT */
    {
        "Float point invalid",
        PURC_EXCEPT_INVALID_FLOAT,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NOT_DESIRED_ENTITY */
    {
        "Not desired entity",
        PURC_EXCEPT_NOT_DESIRED_ENTITY,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_INVALID_OPERAND */
    {
        "Invalid operand",
        PURC_EXCEPT_INVALID_OPERAND,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_ACCESS_DENIED */
    {
        "Access denied",
        PURC_EXCEPT_ACCESS_DENIED,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_IO_FAILURE */
    {
        "IO Failure",
        PURC_EXCEPT_IO_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_TOO_MANY */
    {
        "Too many",
        PURC_EXCEPT_TOO_MANY,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NOT_READY */
    {
        "Not ready",
        PURC_EXCEPT_NOT_READY,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_INCOMPLETED */
    {
        "Incompleted",
        PURC_EXCEPT_INCOMPLETED,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_SYS_FAULT */
    {
        "System fault",
        PURC_EXCEPT_SYS_FAULT,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_TOO_LONG */
    {
        "Too long",
        PURC_EXCEPT_TOO_LONG,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_TIMEOUT */
    {
        "Timeout",
        PURC_EXCEPT_TIMEOUT,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_BROKEN_PIPE */
    {
        "Broken pipe",
        PURC_EXCEPT_BROKEN_PIPE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_CONNECTION_ABORTED */
    {
        "Connection aborted",
        PURC_EXCEPT_CONNECTION_ABORTED,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_CONNECTION_REFUSED */
    {
        "Connection refused",
        PURC_EXCEPT_CONNECTION_REFUSED,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_CONNECTION_RESET */
    {
        "Connection reset",
        PURC_EXCEPT_CONNECTION_RESET,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_DUPLICATE_NAME */
    {
        "Duplicate name",
        PURC_EXCEPT_DUPLICATE_NAME,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_ENTITY_NOT_FOUND */
    {
        "Entity not found",
        PURC_EXCEPT_ENTITY_NOT_FOUND,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NO_DATA */
    {
        "No data",
        PURC_EXCEPT_NO_DATA,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_BAD_NAME */
    {
        "Bad name",
        PURC_EXCEPT_BAD_NAME,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_INTERNAL_FAILURE */
    {
        "Internal failure",
        PURC_EXCEPT_INTERNAL_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_EXTERNAL_FAILURE */
    {
        "External (dynamic variant object) failure",
        PURC_EXCEPT_EXTERNAL_FAILURE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_UNKNOWN */
    {
        "Unknown",
        0,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_REQUEST_FAILED */
    {
        "RequestFailed",
        PURC_EXCEPT_REQUEST_FAILED,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_CHILD_TERMINATED */
    {
        "ChildTerminated",
        PURC_EXCEPT_CHILD_TERMINATED,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_CONFLICT */
    {
        "Conflict",
        PURC_EXCEPT_CONFLICT,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_GONE */
    {
        "Gone",
        PURC_EXCEPT_GONE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_MISMATCHED_VERSION */
    {
        "MismatchedVersion",
        PURC_EXCEPT_MISMATCHED_VERSION,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NOT_ACCEPTABLE */
    {
        "NotAcceptable",
        PURC_EXCEPT_NOT_ACCEPTABLE,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NOT_ALLOWED */
    {
        "NotAllowed",
        PURC_EXCEPT_NOT_ALLOWED,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_NOT_FOUND */
    {
        "NotFound",
        PURC_EXCEPT_NOT_FOUND,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_TOO_EARLY */
    {
        "TooEarly",
        PURC_EXCEPT_TOO_EARLY,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_UNAVAILABLE_LEGALLY */
    {
        "UnavailableLegally",
        PURC_EXCEPT_UNAVAILABLE_LEGALLY,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
    /* PURC_ERROR_UNMET_PRECONDITION */
    {
        "UnmetPrecondition",
        PURC_EXCEPT_UNMET_PRECONDITION,
        PURC_EXCEPT_FLAGS_NONE,
        0
    },
};

