/**
 * @file attr_res.h
 * @date 2021/07/02
 * @brief The hearder file for resource of html tag attribution.
 *
 * Copyright (C) 2021 FMSoft <https://www.fmsoft.cn>
 *
 * This file is a part of PurC (short for Purring Cat), an HVML interpreter.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * The code is derived from Lexbor (<https://github.com/lexbor/lexbor>),
 * which is licensed under the Apache License, Version 2.0:
 *
 * Copyright (C) 2018 Alexander Borisov
 *
 * Author: Alexander Borisov <borisov@lexbor.com>
 */

/*
 * CAUTION:
 * This file generated by the script "attr.py"!
 * Do not change this file!
 */

#ifndef PCHTML_ATTR_RES_H
#define PCHTML_ATTR_RES_H

#include "config.h"
#include "html/shs.h"

#include "html_attr_const.h"


static const pcdom_attr_data_t pcdom_attr_res_data_default[PCDOM_ATTR__LAST_ENTRY] = 
{
    {{.u.short_str = "#undef", .length = 6, .next = NULL},
     PCDOM_ATTR__UNDEF, 1, true},
    {{.u.short_str = "alt", .length = 3, .next = NULL},
     PCDOM_ATTR_ALT, 1, true},
    {{.u.short_str = "charser", .length = 7, .next = NULL},
     PCDOM_ATTR_CHARSER, 1, true},
    {{.u.short_str = "checked", .length = 7, .next = NULL},
     PCDOM_ATTR_CHECKED, 1, true},
    {{.u.short_str = "class", .length = 5, .next = NULL},
     PCDOM_ATTR_CLASS, 1, true},
    {{.u.short_str = "color", .length = 5, .next = NULL},
     PCDOM_ATTR_COLOR, 1, true},
    {{.u.short_str = "content", .length = 7, .next = NULL},
     PCDOM_ATTR_CONTENT, 1, true},
    {{.u.short_str = "dir", .length = 3, .next = NULL},
     PCDOM_ATTR_DIR, 1, true},
    {{.u.short_str = "disabled", .length = 8, .next = NULL},
     PCDOM_ATTR_DISABLED, 1, true},
    {{.u.short_str = "face", .length = 4, .next = NULL},
     PCDOM_ATTR_FACE, 1, true},
    {{.u.short_str = "for", .length = 3, .next = NULL},
     PCDOM_ATTR_FOR, 1, true},
    {{.u.short_str = "height", .length = 6, .next = NULL},
     PCDOM_ATTR_HEIGHT, 1, true},
    {{.u.short_str = "href", .length = 4, .next = NULL},
     PCDOM_ATTR_HREF, 1, true},
    {{.u.short_str = "html", .length = 4, .next = NULL},
     PCDOM_ATTR_HTML, 1, true},
    {{.u.short_str = "http-equiv", .length = 10, .next = NULL},
     PCDOM_ATTR_HTTP_EQUIV, 1, true},
    {{.u.short_str = "id", .length = 2, .next = NULL},
     PCDOM_ATTR_ID, 1, true},
    {{.u.short_str = "is", .length = 2, .next = NULL},
     PCDOM_ATTR_IS, 1, true},
    {{.u.short_str = "maxlength", .length = 9, .next = NULL},
     PCDOM_ATTR_MAXLENGTH, 1, true},
    {{.u.short_str = "pool", .length = 4, .next = NULL},
     PCDOM_ATTR_POOL, 1, true},
    {{.u.short_str = "public", .length = 6, .next = NULL},
     PCDOM_ATTR_PUBLIC, 1, true},
    {{.u.short_str = "scheme", .length = 6, .next = NULL},
     PCDOM_ATTR_SCHEME, 1, true},
    {{.u.short_str = "size", .length = 4, .next = NULL},
     PCDOM_ATTR_SIZE, 1, true},
    {{.u.short_str = "slot", .length = 4, .next = NULL},
     PCDOM_ATTR_SLOT, 1, true},
    {{.u.short_str = "src", .length = 3, .next = NULL},
     PCDOM_ATTR_SRC, 1, true},
    {{.u.short_str = "style", .length = 5, .next = NULL},
     PCDOM_ATTR_STYLE, 1, true},
    {{.u.short_str = "system", .length = 6, .next = NULL},
     PCDOM_ATTR_SYSTEM, 1, true},
    {{.u.short_str = "title", .length = 5, .next = NULL},
     PCDOM_ATTR_TITLE, 1, true},
    {{.u.short_str = "type", .length = 4, .next = NULL},
     PCDOM_ATTR_TYPE, 1, true},
    {{.u.short_str = "width", .length = 5, .next = NULL},
     PCDOM_ATTR_WIDTH, 1, true}
};

static const pchtml_shs_entry_t pcdom_attr_res_shs_data[30] = 
{
    {NULL, NULL, 29, 0}, 
    {(char *)"maxlength", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_MAXLENGTH], 9, 0}, 
    {(char *)"disabled", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_DISABLED], 8, 1}, 
    {(char *)"type", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_TYPE], 4, 0}, 
    {(char *)"alt", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_ALT], 3, 0}, 
    {(char *)"slot", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_SLOT], 4, 3}, 
    {(char *)"title", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_TITLE], 5, 0}, 
    {(char *)"class", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_CLASS], 5, 11}, 
    {(char *)"color", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_COLOR], 5, 12}, 
    {(char *)"http-equiv", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_HTTP_EQUIV], 10, 0}, 
    {(char *)"id", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_ID], 2, 15}, 
    {(char *)"height", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_HEIGHT], 6, 0}, 
    {(char *)"content", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_CONTENT], 7, 0}, 
    {(char *)"html", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_HTML], 4, 0}, 
    {(char *)"dir", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_DIR], 3, 17}, 
    {(char *)"charser", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_CHARSER], 7, 0}, 
    {(char *)"src", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_SRC], 3, 0}, 
    {(char *)"width", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_WIDTH], 5, 0}, 
    {(char *)"for", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_FOR], 3, 0}, 
    {(char *)"href", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_HREF], 4, 26}, 
    {(char *)"style", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_STYLE], 5, 0}, 
    {(char *)"scheme", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_SCHEME], 6, 0}, 
    {(char *)"pool", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_POOL], 4, 0}, 
    {(char *)"face", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_FACE], 4, 0}, 
    {(char *)"checked", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_CHECKED], 7, 0}, 
    {(char *)"#undef", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR__UNDEF], 6, 28}, 
    {(char *)"size", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_SIZE], 4, 0}, 
    {(char *)"is", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_IS], 2, 0}, 
    {(char *)"public", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_PUBLIC], 6, 0}, 
    {(char *)"system", (void *) &pcdom_attr_res_data_default[PCDOM_ATTR_SYSTEM], 6, 0}
};


#endif  /* PCHTML_ATTR_RES_H */
