/**
 * @file html_tag_const.h
 * @date 2021/07/02
 * @brief The hearder file for tag constant.
 *
 * Copyright (C) 2021 FMSoft <https://www.fmsoft.cn>
 *
 * This file is a part of PurC (short for Purring Cat), an HVML interpreter.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * The code is derived from Lexbor (<https://github.com/lexbor/lexbor>),
 * which is licensed under the Apache License, Version 2.0:
 *
 * Copyright (C) 2018 Alexander Borisov
 *
 * Author: Alexander Borisov <borisov@lexbor.com>
 */

/*
 * CAUTION:
 * This file generated by the script "tags.py"!
 * Do not change this file!
 */


#ifndef PCHTML_TAG_CONST_H
#define PCHTML_TAG_CONST_H

#define PCHTML_TAG_CONST_VERSION "B8542F7FAD05D5F6ED2DE2DAA5F870AC"
#define PCHTML_TAG_CONST_VERSION_B8542F7FAD05D5F6ED2DE2DAA5F870AC

/* VW: move to purc-html.h
typedef uintptr_t pchtml_tag_id_t; */

typedef enum {
    PCHTML_TAG__UNDEF              = 0x0000,
    PCHTML_TAG__END_OF_FILE        = 0x0001,
    PCHTML_TAG__TEXT               = 0x0002,
    PCHTML_TAG__DOCUMENT           = 0x0003,
    PCHTML_TAG__EM_COMMENT         = 0x0004,
    PCHTML_TAG__EM_DOCTYPE         = 0x0005,
    PCHTML_TAG_A                   = 0x0006,
    PCHTML_TAG_ABBR                = 0x0007,
    PCHTML_TAG_ACRONYM             = 0x0008,
    PCHTML_TAG_ADDRESS             = 0x0009,
    PCHTML_TAG_ALTGLYPH            = 0x000a,
    PCHTML_TAG_ALTGLYPHDEF         = 0x000b,
    PCHTML_TAG_ALTGLYPHITEM        = 0x000c,
    PCHTML_TAG_ANIMATECOLOR        = 0x000d,
    PCHTML_TAG_ANIMATEMOTION       = 0x000e,
    PCHTML_TAG_ANIMATETRANSFORM    = 0x000f,
    PCHTML_TAG_ANNOTATION_XML      = 0x0010,
    PCHTML_TAG_APPLET              = 0x0011,
    PCHTML_TAG_AREA                = 0x0012,
    PCHTML_TAG_ARTICLE             = 0x0013,
    PCHTML_TAG_ASIDE               = 0x0014,
    PCHTML_TAG_AUDIO               = 0x0015,
    PCHTML_TAG_B                   = 0x0016,
    PCHTML_TAG_BASE                = 0x0017,
    PCHTML_TAG_BASEFONT            = 0x0018,
    PCHTML_TAG_BDI                 = 0x0019,
    PCHTML_TAG_BDO                 = 0x001a,
    PCHTML_TAG_BGSOUND             = 0x001b,
    PCHTML_TAG_BIG                 = 0x001c,
    PCHTML_TAG_BLINK               = 0x001d,
    PCHTML_TAG_BLOCKQUOTE          = 0x001e,
    PCHTML_TAG_BODY                = 0x001f,
    PCHTML_TAG_BR                  = 0x0020,
    PCHTML_TAG_BUTTON              = 0x0021,
    PCHTML_TAG_CANVAS              = 0x0022,
    PCHTML_TAG_CAPTION             = 0x0023,
    PCHTML_TAG_CENTER              = 0x0024,
    PCHTML_TAG_CITE                = 0x0025,
    PCHTML_TAG_CLIPPATH            = 0x0026,
    PCHTML_TAG_CODE                = 0x0027,
    PCHTML_TAG_COL                 = 0x0028,
    PCHTML_TAG_COLGROUP            = 0x0029,
    PCHTML_TAG_DATA                = 0x002a,
    PCHTML_TAG_DATALIST            = 0x002b,
    PCHTML_TAG_DD                  = 0x002c,
    PCHTML_TAG_DEL                 = 0x002d,
    PCHTML_TAG_DESC                = 0x002e,
    PCHTML_TAG_DETAILS             = 0x002f,
    PCHTML_TAG_DFN                 = 0x0030,
    PCHTML_TAG_DIALOG              = 0x0031,
    PCHTML_TAG_DIR                 = 0x0032,
    PCHTML_TAG_DIV                 = 0x0033,
    PCHTML_TAG_DL                  = 0x0034,
    PCHTML_TAG_DT                  = 0x0035,
    PCHTML_TAG_EM                  = 0x0036,
    PCHTML_TAG_EMBED               = 0x0037,
    PCHTML_TAG_FEBLEND             = 0x0038,
    PCHTML_TAG_FECOLORMATRIX       = 0x0039,
    PCHTML_TAG_FECOMPONENTTRANSFER = 0x003a,
    PCHTML_TAG_FECOMPOSITE         = 0x003b,
    PCHTML_TAG_FECONVOLVEMATRIX    = 0x003c,
    PCHTML_TAG_FEDIFFUSELIGHTING   = 0x003d,
    PCHTML_TAG_FEDISPLACEMENTMAP   = 0x003e,
    PCHTML_TAG_FEDISTANTLIGHT      = 0x003f,
    PCHTML_TAG_FEDROPSHADOW        = 0x0040,
    PCHTML_TAG_FEFLOOD             = 0x0041,
    PCHTML_TAG_FEFUNCA             = 0x0042,
    PCHTML_TAG_FEFUNCB             = 0x0043,
    PCHTML_TAG_FEFUNCG             = 0x0044,
    PCHTML_TAG_FEFUNCR             = 0x0045,
    PCHTML_TAG_FEGAUSSIANBLUR      = 0x0046,
    PCHTML_TAG_FEIMAGE             = 0x0047,
    PCHTML_TAG_FEMERGE             = 0x0048,
    PCHTML_TAG_FEMERGENODE         = 0x0049,
    PCHTML_TAG_FEMORPHOLOGY        = 0x004a,
    PCHTML_TAG_FEOFFSET            = 0x004b,
    PCHTML_TAG_FEPOINTLIGHT        = 0x004c,
    PCHTML_TAG_FESPECULARLIGHTING  = 0x004d,
    PCHTML_TAG_FESPOTLIGHT         = 0x004e,
    PCHTML_TAG_FETILE              = 0x004f,
    PCHTML_TAG_FETURBULENCE        = 0x0050,
    PCHTML_TAG_FIELDSET            = 0x0051,
    PCHTML_TAG_FIGCAPTION          = 0x0052,
    PCHTML_TAG_FIGURE              = 0x0053,
    PCHTML_TAG_FONT                = 0x0054,
    PCHTML_TAG_FOOTER              = 0x0055,
    PCHTML_TAG_FOREIGNOBJECT       = 0x0056,
    PCHTML_TAG_FORM                = 0x0057,
    PCHTML_TAG_FRAME               = 0x0058,
    PCHTML_TAG_FRAMESET            = 0x0059,
    PCHTML_TAG_GLYPHREF            = 0x005a,
    PCHTML_TAG_H1                  = 0x005b,
    PCHTML_TAG_H2                  = 0x005c,
    PCHTML_TAG_H3                  = 0x005d,
    PCHTML_TAG_H4                  = 0x005e,
    PCHTML_TAG_H5                  = 0x005f,
    PCHTML_TAG_H6                  = 0x0060,
    PCHTML_TAG_HEAD                = 0x0061,
    PCHTML_TAG_HEADER              = 0x0062,
    PCHTML_TAG_HGROUP              = 0x0063,
    PCHTML_TAG_HR                  = 0x0064,
    PCHTML_TAG_HTML                = 0x0065,
    PCHTML_TAG_I                   = 0x0066,
    PCHTML_TAG_IFRAME              = 0x0067,
    PCHTML_TAG_IMAGE               = 0x0068,
    PCHTML_TAG_IMG                 = 0x0069,
    PCHTML_TAG_INPUT               = 0x006a,
    PCHTML_TAG_INS                 = 0x006b,
    PCHTML_TAG_ISINDEX             = 0x006c,
    PCHTML_TAG_KBD                 = 0x006d,
    PCHTML_TAG_KEYGEN              = 0x006e,
    PCHTML_TAG_LABEL               = 0x006f,
    PCHTML_TAG_LEGEND              = 0x0070,
    PCHTML_TAG_LI                  = 0x0071,
    PCHTML_TAG_LINEARGRADIENT      = 0x0072,
    PCHTML_TAG_LINK                = 0x0073,
    PCHTML_TAG_LISTING             = 0x0074,
    PCHTML_TAG_MAIN                = 0x0075,
    PCHTML_TAG_MALIGNMARK          = 0x0076,
    PCHTML_TAG_MAP                 = 0x0077,
    PCHTML_TAG_MARK                = 0x0078,
    PCHTML_TAG_MARQUEE             = 0x0079,
    PCHTML_TAG_MATH                = 0x007a,
    PCHTML_TAG_MENU                = 0x007b,
    PCHTML_TAG_META                = 0x007c,
    PCHTML_TAG_METER               = 0x007d,
    PCHTML_TAG_MFENCED             = 0x007e,
    PCHTML_TAG_MGLYPH              = 0x007f,
    PCHTML_TAG_MI                  = 0x0080,
    PCHTML_TAG_MN                  = 0x0081,
    PCHTML_TAG_MO                  = 0x0082,
    PCHTML_TAG_MS                  = 0x0083,
    PCHTML_TAG_MTEXT               = 0x0084,
    PCHTML_TAG_MULTICOL            = 0x0085,
    PCHTML_TAG_NAV                 = 0x0086,
    PCHTML_TAG_NEXTID              = 0x0087,
    PCHTML_TAG_NOBR                = 0x0088,
    PCHTML_TAG_NOEMBED             = 0x0089,
    PCHTML_TAG_NOFRAMES            = 0x008a,
    PCHTML_TAG_NOSCRIPT            = 0x008b,
    PCHTML_TAG_OBJECT              = 0x008c,
    PCHTML_TAG_OL                  = 0x008d,
    PCHTML_TAG_OPTGROUP            = 0x008e,
    PCHTML_TAG_OPTION              = 0x008f,
    PCHTML_TAG_OUTPUT              = 0x0090,
    PCHTML_TAG_P                   = 0x0091,
    PCHTML_TAG_PARAM               = 0x0092,
    PCHTML_TAG_PATH                = 0x0093,
    PCHTML_TAG_PICTURE             = 0x0094,
    PCHTML_TAG_PLAINTEXT           = 0x0095,
    PCHTML_TAG_PRE                 = 0x0096,
    PCHTML_TAG_PROGRESS            = 0x0097,
    PCHTML_TAG_Q                   = 0x0098,
    PCHTML_TAG_RADIALGRADIENT      = 0x0099,
    PCHTML_TAG_RB                  = 0x009a,
    PCHTML_TAG_RP                  = 0x009b,
    PCHTML_TAG_RT                  = 0x009c,
    PCHTML_TAG_RTC                 = 0x009d,
    PCHTML_TAG_RUBY                = 0x009e,
    PCHTML_TAG_S                   = 0x009f,
    PCHTML_TAG_SAMP                = 0x00a0,
    PCHTML_TAG_SCRIPT              = 0x00a1,
    PCHTML_TAG_SECTION             = 0x00a2,
    PCHTML_TAG_SELECT              = 0x00a3,
    PCHTML_TAG_SLOT                = 0x00a4,
    PCHTML_TAG_SMALL               = 0x00a5,
    PCHTML_TAG_SOURCE              = 0x00a6,
    PCHTML_TAG_SPACER              = 0x00a7,
    PCHTML_TAG_SPAN                = 0x00a8,
    PCHTML_TAG_STRIKE              = 0x00a9,
    PCHTML_TAG_STRONG              = 0x00aa,
    PCHTML_TAG_STYLE               = 0x00ab,
    PCHTML_TAG_SUB                 = 0x00ac,
    PCHTML_TAG_SUMMARY             = 0x00ad,
    PCHTML_TAG_SUP                 = 0x00ae,
    PCHTML_TAG_SVG                 = 0x00af,
    PCHTML_TAG_TABLE               = 0x00b0,
    PCHTML_TAG_TBODY               = 0x00b1,
    PCHTML_TAG_TD                  = 0x00b2,
    PCHTML_TAG_TEMPLATE            = 0x00b3,
    PCHTML_TAG_TEXTAREA            = 0x00b4,
    PCHTML_TAG_TEXTPATH            = 0x00b5,
    PCHTML_TAG_TFOOT               = 0x00b6,
    PCHTML_TAG_TH                  = 0x00b7,
    PCHTML_TAG_THEAD               = 0x00b8,
    PCHTML_TAG_TIME                = 0x00b9,
    PCHTML_TAG_TITLE               = 0x00ba,
    PCHTML_TAG_TR                  = 0x00bb,
    PCHTML_TAG_TRACK               = 0x00bc,
    PCHTML_TAG_TT                  = 0x00bd,
    PCHTML_TAG_U                   = 0x00be,
    PCHTML_TAG_UL                  = 0x00bf,
    PCHTML_TAG_VAR                 = 0x00c0,
    PCHTML_TAG_VIDEO               = 0x00c1,
    PCHTML_TAG_WBR                 = 0x00c2,
    PCHTML_TAG_XMP                 = 0x00c3,
    PCHTML_TAG__LAST_ENTRY         = 0x00c4
}
pchtml_tag_id_enum_t;

#endif /* PCHTML_TAG_CONST_H */

