/**
 * @file html_tag_res_ext.h
 * @date 2021/07/02
 * @brief The hearder file for resource of html tag.
 *
 * Copyright (C) 2021 FMSoft <https://www.fmsoft.cn>
 *
 * This file is a part of PurC (short for Purring Cat), an HVML interpreter.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * The code is derived from Lexbor (<https://github.com/lexbor/lexbor>),
 * which is licensed under the Apache License, Version 2.0:
 *
 * Copyright (C) 2018 Alexander Borisov
 *
 * Author: Alexander Borisov <borisov@lexbor.com>
 */

/*
 * CAUTION:
 * This file generated by the script "tags.py"!
 * Do not change this file!
 */

#ifndef PCHTML_HTML_TAG_RES_EXT_H
#define PCHTML_HTML_TAG_RES_EXT_H

#include "html/tag.h"

#ifdef PCHTML_TAG_CONST_VERSION
#ifndef PCHTML_TAG_CONST_VERSION_B8542F7FAD05D5F6ED2DE2DAA5F870AC
#error Mismatched tags version! See "lexbor/tag/const.h".
#endif /* PCHTML_TAG_CONST_VERSION_B8542F7FAD05D5F6ED2DE2DAA5F870AC */
#else
#error You need to include "lexbor/tag/const.h".
#endif /* PCHTML_TAG_CONST_VERSION */

#ifdef PCHTML_NS_CONST_VERSION
#ifndef PCHTML_NS_CONST_VERSION_203D1192AD2D6A84078C4ECF7E381FCB
#error Mismatched namespaces version! See "lexbor/ns/const.h".
#endif /* PCHTML_NS_CONST_VERSION_203D1192AD2D6A84078C4ECF7E381FCB */
#else
#error You need to include "lexbor/ns/const.h".
#endif /* PCHTML_NS_CONST_VERSION */

#ifdef PCHTML_HTML_TAG_RES_CATS
#ifndef PCHTML_HTML_TAG_RES_CATS_ENABLED
#define PCHTML_HTML_TAG_RES_CATS_ENABLED
static  pchtml_html_tag_category_t pchtml_html_tag_res_cats[PCHTML_TAG__LAST_ENTRY][PCHTML_NS__LAST_ENTRY] = 
{
    /* PCHTML_TAG__UNDEF */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG__END_OF_FILE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG__TEXT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG__DOCUMENT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG__EM_COMMENT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG__EM_DOCTYPE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_A */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ABBR */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ACRONYM */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ADDRESS */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ALTGLYPH */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ALTGLYPHDEF */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ALTGLYPHITEM */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ANIMATECOLOR */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ANIMATEMOTION */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ANIMATETRANSFORM */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ANNOTATION_XML */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_APPLET */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_AREA */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ARTICLE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ASIDE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_AUDIO */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_B */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_BASE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_BASEFONT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_BDI */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_BDO */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_BGSOUND */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_BIG */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_BLINK */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_BLOCKQUOTE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_BODY */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_BR */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_BUTTON */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_CANVAS */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_CAPTION */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_CENTER */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_CITE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_CLIPPATH */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_CODE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_COL */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_COLGROUP */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DATA */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DATALIST */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DD */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DEL */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DESC */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DETAILS */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DFN */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DIALOG */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DIR */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DIV */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DL */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_DT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_EM */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_EMBED */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEBLEND */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FECOLORMATRIX */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FECOMPONENTTRANSFER */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FECOMPOSITE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FECONVOLVEMATRIX */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEDIFFUSELIGHTING */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEDISPLACEMENTMAP */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEDISTANTLIGHT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEDROPSHADOW */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEFLOOD */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEFUNCA */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEFUNCB */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEFUNCG */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEFUNCR */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEGAUSSIANBLUR */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEIMAGE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEMERGE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEMERGENODE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEMORPHOLOGY */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEOFFSET */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FEPOINTLIGHT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FESPECULARLIGHTING */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FESPOTLIGHT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FETILE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FETURBULENCE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FIELDSET */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FIGCAPTION */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FIGURE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FONT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FOOTER */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FOREIGNOBJECT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FORM */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FRAME */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_FRAMESET */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_GLYPHREF */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_H1 */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_H2 */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_H3 */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_H4 */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_H5 */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_H6 */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_HEAD */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_HEADER */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_HGROUP */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_HR */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_HTML */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_TABLE
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_I */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_IFRAME */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_IMAGE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_IMG */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_INPUT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_INS */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_ISINDEX */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_KBD */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_KEYGEN */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_LABEL */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_LEGEND */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_LI */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_LINEARGRADIENT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_LINK */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_LISTING */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MAIN */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MALIGNMARK */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY_ORDINARY,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MAP */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MARK */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MARQUEE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MATH */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MENU */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_META */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_METER */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MFENCED */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MGLYPH */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY_ORDINARY,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MI */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MN */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MO */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MS */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MTEXT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_MULTICOL */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_NAV */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_NEXTID */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_NOBR */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_NOEMBED */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_NOFRAMES */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_NOSCRIPT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_OBJECT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_OL */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_OPTGROUP */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY,PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_OPTION */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY,PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_OUTPUT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_P */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_PARAM */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_PATH */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_PICTURE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_PLAINTEXT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_PRE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_PROGRESS */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_Q */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_RADIALGRADIENT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_RB */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_RP */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_RT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_RTC */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_RUBY */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_S */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SAMP */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SCRIPT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SECTION */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SELECT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SLOT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SMALL */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SOURCE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SPACER */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SPAN */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_STRIKE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_STRONG */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_STYLE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SUB */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SUMMARY */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SUP */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_SVG */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TABLE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_TABLE
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TBODY */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TD */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TEMPLATE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_TABLE
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TEXTAREA */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TEXTPATH */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TFOOT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TH */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_THEAD */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TIME */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TITLE */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_BUTTON
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TR */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TRACK */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_TT */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_U */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_FORMATTING
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_UL */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_LIST_ITEM
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_VAR */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_VIDEO */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_ORDINARY
            |PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_WBR */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    },
    /* PCHTML_TAG_XMP */
    {
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY_SCOPE_SELECT
            |PCHTML_HTML_TAG_CATEGORY_SPECIAL,
        PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF, 
        PCHTML_HTML_TAG_CATEGORY__UNDEF, PCHTML_HTML_TAG_CATEGORY__UNDEF
    }
};
#endif /* PCHTML_HTML_TAG_RES_CATS_ENABLED */
#endif /* PCHTML_HTML_TAG_RES_CATS */

#ifdef PCHTML_HTML_TAG_RES_FIXNAME_SVG
#ifndef PCHTML_HTML_TAG_RES_FIXNAME_SVG_ENABLED
#define PCHTML_HTML_TAG_RES_FIXNAME_SVG_ENABLED
static  pchtml_html_tag_fixname_t pchtml_html_tag_res_fixname_svg[PCHTML_TAG__LAST_ENTRY] = 
{
    /* PCHTML_TAG__UNDEF */
    {NULL, 0},
    /* PCHTML_TAG__END_OF_FILE */
    {NULL, 0},
    /* PCHTML_TAG__TEXT */
    {NULL, 0},
    /* PCHTML_TAG__DOCUMENT */
    {NULL, 0},
    /* PCHTML_TAG__EM_COMMENT */
    {NULL, 0},
    /* PCHTML_TAG__EM_DOCTYPE */
    {NULL, 0},
    /* PCHTML_TAG_A */
    {NULL, 0},
    /* PCHTML_TAG_ABBR */
    {NULL, 0},
    /* PCHTML_TAG_ACRONYM */
    {NULL, 0},
    /* PCHTML_TAG_ADDRESS */
    {NULL, 0},
    /* PCHTML_TAG_ALTGLYPH */
    {(const unsigned char *) "altGlyph", 8},
    /* PCHTML_TAG_ALTGLYPHDEF */
    {(const unsigned char *) "altGlyphDef", 11},
    /* PCHTML_TAG_ALTGLYPHITEM */
    {(const unsigned char *) "altGlyphItem", 12},
    /* PCHTML_TAG_ANIMATECOLOR */
    {(const unsigned char *) "animateColor", 12},
    /* PCHTML_TAG_ANIMATEMOTION */
    {(const unsigned char *) "animateMotion", 13},
    /* PCHTML_TAG_ANIMATETRANSFORM */
    {(const unsigned char *) "animateTransform", 16},
    /* PCHTML_TAG_ANNOTATION_XML */
    {NULL, 0},
    /* PCHTML_TAG_APPLET */
    {NULL, 0},
    /* PCHTML_TAG_AREA */
    {NULL, 0},
    /* PCHTML_TAG_ARTICLE */
    {NULL, 0},
    /* PCHTML_TAG_ASIDE */
    {NULL, 0},
    /* PCHTML_TAG_AUDIO */
    {NULL, 0},
    /* PCHTML_TAG_B */
    {NULL, 0},
    /* PCHTML_TAG_BASE */
    {NULL, 0},
    /* PCHTML_TAG_BASEFONT */
    {NULL, 0},
    /* PCHTML_TAG_BDI */
    {NULL, 0},
    /* PCHTML_TAG_BDO */
    {NULL, 0},
    /* PCHTML_TAG_BGSOUND */
    {NULL, 0},
    /* PCHTML_TAG_BIG */
    {NULL, 0},
    /* PCHTML_TAG_BLINK */
    {NULL, 0},
    /* PCHTML_TAG_BLOCKQUOTE */
    {NULL, 0},
    /* PCHTML_TAG_BODY */
    {NULL, 0},
    /* PCHTML_TAG_BR */
    {NULL, 0},
    /* PCHTML_TAG_BUTTON */
    {NULL, 0},
    /* PCHTML_TAG_CANVAS */
    {NULL, 0},
    /* PCHTML_TAG_CAPTION */
    {NULL, 0},
    /* PCHTML_TAG_CENTER */
    {NULL, 0},
    /* PCHTML_TAG_CITE */
    {NULL, 0},
    /* PCHTML_TAG_CLIPPATH */
    {(const unsigned char *) "clipPath", 8},
    /* PCHTML_TAG_CODE */
    {NULL, 0},
    /* PCHTML_TAG_COL */
    {NULL, 0},
    /* PCHTML_TAG_COLGROUP */
    {NULL, 0},
    /* PCHTML_TAG_DATA */
    {NULL, 0},
    /* PCHTML_TAG_DATALIST */
    {NULL, 0},
    /* PCHTML_TAG_DD */
    {NULL, 0},
    /* PCHTML_TAG_DEL */
    {NULL, 0},
    /* PCHTML_TAG_DESC */
    {NULL, 0},
    /* PCHTML_TAG_DETAILS */
    {NULL, 0},
    /* PCHTML_TAG_DFN */
    {NULL, 0},
    /* PCHTML_TAG_DIALOG */
    {NULL, 0},
    /* PCHTML_TAG_DIR */
    {NULL, 0},
    /* PCHTML_TAG_DIV */
    {NULL, 0},
    /* PCHTML_TAG_DL */
    {NULL, 0},
    /* PCHTML_TAG_DT */
    {NULL, 0},
    /* PCHTML_TAG_EM */
    {NULL, 0},
    /* PCHTML_TAG_EMBED */
    {NULL, 0},
    /* PCHTML_TAG_FEBLEND */
    {(const unsigned char *) "feBlend", 7},
    /* PCHTML_TAG_FECOLORMATRIX */
    {(const unsigned char *) "feColorMatrix", 13},
    /* PCHTML_TAG_FECOMPONENTTRANSFER */
    {(const unsigned char *) "feComponentTransfer", 19},
    /* PCHTML_TAG_FECOMPOSITE */
    {(const unsigned char *) "feComposite", 11},
    /* PCHTML_TAG_FECONVOLVEMATRIX */
    {(const unsigned char *) "feConvolveMatrix", 16},
    /* PCHTML_TAG_FEDIFFUSELIGHTING */
    {(const unsigned char *) "feDiffuseLighting", 17},
    /* PCHTML_TAG_FEDISPLACEMENTMAP */
    {(const unsigned char *) "feDisplacementMap", 17},
    /* PCHTML_TAG_FEDISTANTLIGHT */
    {(const unsigned char *) "feDistantLight", 14},
    /* PCHTML_TAG_FEDROPSHADOW */
    {(const unsigned char *) "feDropShadow", 12},
    /* PCHTML_TAG_FEFLOOD */
    {(const unsigned char *) "feFlood", 7},
    /* PCHTML_TAG_FEFUNCA */
    {(const unsigned char *) "feFuncA", 7},
    /* PCHTML_TAG_FEFUNCB */
    {(const unsigned char *) "feFuncB", 7},
    /* PCHTML_TAG_FEFUNCG */
    {(const unsigned char *) "feFuncG", 7},
    /* PCHTML_TAG_FEFUNCR */
    {(const unsigned char *) "feFuncR", 7},
    /* PCHTML_TAG_FEGAUSSIANBLUR */
    {(const unsigned char *) "feGaussianBlur", 14},
    /* PCHTML_TAG_FEIMAGE */
    {(const unsigned char *) "feImage", 7},
    /* PCHTML_TAG_FEMERGE */
    {(const unsigned char *) "feMerge", 7},
    /* PCHTML_TAG_FEMERGENODE */
    {(const unsigned char *) "feMergeNode", 11},
    /* PCHTML_TAG_FEMORPHOLOGY */
    {(const unsigned char *) "feMorphology", 12},
    /* PCHTML_TAG_FEOFFSET */
    {(const unsigned char *) "feOffset", 8},
    /* PCHTML_TAG_FEPOINTLIGHT */
    {(const unsigned char *) "fePointLight", 12},
    /* PCHTML_TAG_FESPECULARLIGHTING */
    {(const unsigned char *) "feSpecularLighting", 18},
    /* PCHTML_TAG_FESPOTLIGHT */
    {(const unsigned char *) "feSpotLight", 11},
    /* PCHTML_TAG_FETILE */
    {(const unsigned char *) "feTile", 6},
    /* PCHTML_TAG_FETURBULENCE */
    {(const unsigned char *) "feTurbulence", 12},
    /* PCHTML_TAG_FIELDSET */
    {NULL, 0},
    /* PCHTML_TAG_FIGCAPTION */
    {NULL, 0},
    /* PCHTML_TAG_FIGURE */
    {NULL, 0},
    /* PCHTML_TAG_FONT */
    {NULL, 0},
    /* PCHTML_TAG_FOOTER */
    {NULL, 0},
    /* PCHTML_TAG_FOREIGNOBJECT */
    {(const unsigned char *) "foreignObject", 13},
    /* PCHTML_TAG_FORM */
    {NULL, 0},
    /* PCHTML_TAG_FRAME */
    {NULL, 0},
    /* PCHTML_TAG_FRAMESET */
    {NULL, 0},
    /* PCHTML_TAG_GLYPHREF */
    {(const unsigned char *) "glyphRef", 8},
    /* PCHTML_TAG_H1 */
    {NULL, 0},
    /* PCHTML_TAG_H2 */
    {NULL, 0},
    /* PCHTML_TAG_H3 */
    {NULL, 0},
    /* PCHTML_TAG_H4 */
    {NULL, 0},
    /* PCHTML_TAG_H5 */
    {NULL, 0},
    /* PCHTML_TAG_H6 */
    {NULL, 0},
    /* PCHTML_TAG_HEAD */
    {NULL, 0},
    /* PCHTML_TAG_HEADER */
    {NULL, 0},
    /* PCHTML_TAG_HGROUP */
    {NULL, 0},
    /* PCHTML_TAG_HR */
    {NULL, 0},
    /* PCHTML_TAG_HTML */
    {NULL, 0},
    /* PCHTML_TAG_I */
    {NULL, 0},
    /* PCHTML_TAG_IFRAME */
    {NULL, 0},
    /* PCHTML_TAG_IMAGE */
    {NULL, 0},
    /* PCHTML_TAG_IMG */
    {NULL, 0},
    /* PCHTML_TAG_INPUT */
    {NULL, 0},
    /* PCHTML_TAG_INS */
    {NULL, 0},
    /* PCHTML_TAG_ISINDEX */
    {NULL, 0},
    /* PCHTML_TAG_KBD */
    {NULL, 0},
    /* PCHTML_TAG_KEYGEN */
    {NULL, 0},
    /* PCHTML_TAG_LABEL */
    {NULL, 0},
    /* PCHTML_TAG_LEGEND */
    {NULL, 0},
    /* PCHTML_TAG_LI */
    {NULL, 0},
    /* PCHTML_TAG_LINEARGRADIENT */
    {(const unsigned char *) "linearGradient", 14},
    /* PCHTML_TAG_LINK */
    {NULL, 0},
    /* PCHTML_TAG_LISTING */
    {NULL, 0},
    /* PCHTML_TAG_MAIN */
    {NULL, 0},
    /* PCHTML_TAG_MALIGNMARK */
    {NULL, 0},
    /* PCHTML_TAG_MAP */
    {NULL, 0},
    /* PCHTML_TAG_MARK */
    {NULL, 0},
    /* PCHTML_TAG_MARQUEE */
    {NULL, 0},
    /* PCHTML_TAG_MATH */
    {NULL, 0},
    /* PCHTML_TAG_MENU */
    {NULL, 0},
    /* PCHTML_TAG_META */
    {NULL, 0},
    /* PCHTML_TAG_METER */
    {NULL, 0},
    /* PCHTML_TAG_MFENCED */
    {NULL, 0},
    /* PCHTML_TAG_MGLYPH */
    {NULL, 0},
    /* PCHTML_TAG_MI */
    {NULL, 0},
    /* PCHTML_TAG_MN */
    {NULL, 0},
    /* PCHTML_TAG_MO */
    {NULL, 0},
    /* PCHTML_TAG_MS */
    {NULL, 0},
    /* PCHTML_TAG_MTEXT */
    {NULL, 0},
    /* PCHTML_TAG_MULTICOL */
    {NULL, 0},
    /* PCHTML_TAG_NAV */
    {NULL, 0},
    /* PCHTML_TAG_NEXTID */
    {NULL, 0},
    /* PCHTML_TAG_NOBR */
    {NULL, 0},
    /* PCHTML_TAG_NOEMBED */
    {NULL, 0},
    /* PCHTML_TAG_NOFRAMES */
    {NULL, 0},
    /* PCHTML_TAG_NOSCRIPT */
    {NULL, 0},
    /* PCHTML_TAG_OBJECT */
    {NULL, 0},
    /* PCHTML_TAG_OL */
    {NULL, 0},
    /* PCHTML_TAG_OPTGROUP */
    {NULL, 0},
    /* PCHTML_TAG_OPTION */
    {NULL, 0},
    /* PCHTML_TAG_OUTPUT */
    {NULL, 0},
    /* PCHTML_TAG_P */
    {NULL, 0},
    /* PCHTML_TAG_PARAM */
    {NULL, 0},
    /* PCHTML_TAG_PATH */
    {NULL, 0},
    /* PCHTML_TAG_PICTURE */
    {NULL, 0},
    /* PCHTML_TAG_PLAINTEXT */
    {NULL, 0},
    /* PCHTML_TAG_PRE */
    {NULL, 0},
    /* PCHTML_TAG_PROGRESS */
    {NULL, 0},
    /* PCHTML_TAG_Q */
    {NULL, 0},
    /* PCHTML_TAG_RADIALGRADIENT */
    {(const unsigned char *) "radialGradient", 14},
    /* PCHTML_TAG_RB */
    {NULL, 0},
    /* PCHTML_TAG_RP */
    {NULL, 0},
    /* PCHTML_TAG_RT */
    {NULL, 0},
    /* PCHTML_TAG_RTC */
    {NULL, 0},
    /* PCHTML_TAG_RUBY */
    {NULL, 0},
    /* PCHTML_TAG_S */
    {NULL, 0},
    /* PCHTML_TAG_SAMP */
    {NULL, 0},
    /* PCHTML_TAG_SCRIPT */
    {NULL, 0},
    /* PCHTML_TAG_SECTION */
    {NULL, 0},
    /* PCHTML_TAG_SELECT */
    {NULL, 0},
    /* PCHTML_TAG_SLOT */
    {NULL, 0},
    /* PCHTML_TAG_SMALL */
    {NULL, 0},
    /* PCHTML_TAG_SOURCE */
    {NULL, 0},
    /* PCHTML_TAG_SPACER */
    {NULL, 0},
    /* PCHTML_TAG_SPAN */
    {NULL, 0},
    /* PCHTML_TAG_STRIKE */
    {NULL, 0},
    /* PCHTML_TAG_STRONG */
    {NULL, 0},
    /* PCHTML_TAG_STYLE */
    {NULL, 0},
    /* PCHTML_TAG_SUB */
    {NULL, 0},
    /* PCHTML_TAG_SUMMARY */
    {NULL, 0},
    /* PCHTML_TAG_SUP */
    {NULL, 0},
    /* PCHTML_TAG_SVG */
    {NULL, 0},
    /* PCHTML_TAG_TABLE */
    {NULL, 0},
    /* PCHTML_TAG_TBODY */
    {NULL, 0},
    /* PCHTML_TAG_TD */
    {NULL, 0},
    /* PCHTML_TAG_TEMPLATE */
    {NULL, 0},
    /* PCHTML_TAG_TEXTAREA */
    {NULL, 0},
    /* PCHTML_TAG_TEXTPATH */
    {(const unsigned char *) "textPath", 8},
    /* PCHTML_TAG_TFOOT */
    {NULL, 0},
    /* PCHTML_TAG_TH */
    {NULL, 0},
    /* PCHTML_TAG_THEAD */
    {NULL, 0},
    /* PCHTML_TAG_TIME */
    {NULL, 0},
    /* PCHTML_TAG_TITLE */
    {NULL, 0},
    /* PCHTML_TAG_TR */
    {NULL, 0},
    /* PCHTML_TAG_TRACK */
    {NULL, 0},
    /* PCHTML_TAG_TT */
    {NULL, 0},
    /* PCHTML_TAG_U */
    {NULL, 0},
    /* PCHTML_TAG_UL */
    {NULL, 0},
    /* PCHTML_TAG_VAR */
    {NULL, 0},
    /* PCHTML_TAG_VIDEO */
    {NULL, 0},
    /* PCHTML_TAG_WBR */
    {NULL, 0},
    /* PCHTML_TAG_XMP */
    {NULL, 0},
    
};
#endif /* PCHTML_HTML_TAG_RES_FIXNAME_SVG_ENABLED */
#endif /* PCHTML_HTML_TAG_RES_FIXNAME_SVG */

#endif /* PCHTML_HTML_TAG_RES_EXT_H */

