/*
** Copyright (C) 2021 FMSoft <https://www.fmsoft.cn>
**
** This file is a part of Purring Cat 2, a HVML parser and interpreter.
** 
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU Lesser General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU Lesser General Public License for more details.
**
** You should have received a copy of the GNU Lesser General Public License
** along with this program.  If not, see <https://www.gnu.org/licenses/>.
**
** Author: Vincent Wei <https://github.com/VincentWei>
*/

// NOTE
// This file is auto-generated by using 'make_hvml_attrs_table.py'.
// Please take care when you modify this file mannually.

#ifndef _HVML_ATTR_H
#define _HVML_ATTR_H

#include "config.h"
#include "purc-macros.h"

PCA_EXTERN_C_BEGIN

enum pchvml_attr_type {
    PCHVML_ATTR_TYPE_ORDINARY = 0,
    PCHVML_ATTR_TYPE_ADVERB,
    PCHVML_ATTR_TYPE_PREP,
    PCHVML_ATTR_TYPE_UPDATE,
    PCHVML_ATTR_TYPE_LAST_ENTRY,
};

struct pchvml_attr_entry {
    const char* name;
    enum pchvml_attr_type type;
    short next;
};

const struct pchvml_attr_entry*
pchvml_attr_static_search(const char* name, size_t length);

PCA_EXTERN_C_END

#endif // _HVML_ATTR_H

