/*
** Copyright (C) 2021 FMSoft <https://www.fmsoft.cn>
**
** This file is a part of Purring Cat 2, a HVML parser and interpreter.
** 
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU Lesser General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU Lesser General Public License for more details.
**
** You should have received a copy of the GNU Lesser General Public License
** along with this program.  If not, see <https://www.gnu.org/licenses/>.
**
** Author: Vincent Wei <https://github.com/VincentWei>
*/

// NOTE
// This file is auto-generated by using 'make_hvml_tags_table.py'.
// Please take care when you modify this file mannually.

#ifndef _HVML_TAG_H
#define _HVML_TAG_H

#include "config.h"
#include "purc-macros.h"

PCA_EXTERN_C_BEGIN

enum pchvml_tag_id {
    PCHVML_TAG__UNDEF = 0,
    PCHVML_TAG__TEXT,
    PCHVML_TAG__COMMENT,
    PCHVML_TAG__FOREIGN,
    PCHVML_TAG__DOCTYPE,
    PCHVML_TAG_HVML,
    PCHVML_TAG_HEAD,
    PCHVML_TAG_BODY,
    PCHVML_TAG_ARCHETYPE,
    PCHVML_TAG_ERROR,
    PCHVML_TAG_EXCEPT,
    PCHVML_TAG_ARCHEDATA,
    PCHVML_TAG_BACK,
    PCHVML_TAG_BIND,
    PCHVML_TAG_CALL,
    PCHVML_TAG_CATCH,
    PCHVML_TAG_CHOOSE,
    PCHVML_TAG_CLOSE,
    PCHVML_TAG_CLEAR,
    PCHVML_TAG_CONNECT,
    PCHVML_TAG_DEFINE,
    PCHVML_TAG_ERASE,
    PCHVML_TAG_EXIT,
    PCHVML_TAG_INCLUDE,
    PCHVML_TAG_ITERATE,
    PCHVML_TAG_LISTEN,
    PCHVML_TAG_LOAD,
    PCHVML_TAG_MATCH,
    PCHVML_TAG_OBSERVE,
    PCHVML_TAG_REQUEST,
    PCHVML_TAG_REDUCE,
    PCHVML_TAG_RETURN,
    PCHVML_TAG_SLEEP,
    PCHVML_TAG_TEST,
    PCHVML_TAG_UPDATE,
    PCHVML_TAG_FORGET,
    PCHVML_TAG_FIRE,
    PCHVML_TAG_INHERIT,
    PCHVML_TAG_DIFFER,
    PCHVML_TAG_SORT,
    PCHVML_TAG_INIT,
    PCHVML_TAG_SET,
    PCHVML_TAG__END_OF_FILE,
    PCHVML_TAG_FIRST_ENTRY = PCHVML_TAG__TEXT,
    PCHVML_TAG_LAST_ENTRY  = PCHVML_TAG__END_OF_FILE + 1,
};

enum pchvml_tokenizer_state {
    PCHVML_TOKENIZER_STATE_DATA = 0,
    PCHVML_TOKENIZER_STATE_RAWTEXT = 1,
};

enum pchvml_tag_category {
    PCHVML_TAGCAT__UNDEF = 0x00,
    PCHVML_TAGCAT_NOUN = 0x1,
    PCHVML_TAGCAT_ORDINARY = 0x2,
    PCHVML_TAGCAT_FOREIGN = 0x4,
    PCHVML_TAGCAT_SPECIAL = 0x8,
    PCHVML_TAGCAT_FRAMEWORK = 0x10,
    PCHVML_TAGCAT_TEMPLATE = 0x20,
    PCHVML_TAGCAT_FRAGMENT = 0x40,
    PCHVML_TAGCAT_DATA = 0x80,
    PCHVML_TAGCAT_VERB = 0x100,
};

struct pchvml_tag_entry {
    enum pchvml_tag_id id;

    const char* name;
    size_t name_length;

    enum pchvml_tokenizer_state data_parser;
    enum pchvml_tag_category    cats; // bit-or
};

struct pchvml_tag_static_list {
    const struct pchvml_tag_entry* ctx;
    size_t next;
};

const struct pchvml_tag_entry*
pchvml_tag_static_get_by_id(enum pchvml_tag_id id);
const struct pchvml_tag_entry*
pchvml_tag_static_search(const char* name, size_t length);

PCA_EXTERN_C_END

#endif // _HVML_TAG_H

