/*
** Copyright (C) 2021 FMSoft <https://www.fmsoft.cn>
**
** This file is a part of Purring Cat 2, a HVML parser and interpreter.
** 
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU Lesser General Public License as published by
** the Free Software Foundation, either version 3 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU Lesser General Public License for more details.
**
** You should have received a copy of the GNU Lesser General Public License
** along with this program.  If not, see <https://www.gnu.org/licenses/>.
**
** Author: Vincent Wei <https://github.com/VincentWei>
*/

// NOTE
// This file is auto-generated by using 'make_keywords.py'.
// Please take care when you modify this file mannually.

#include "private/instance.h"

static struct pchvml_keyword_cfg keywords[] = {
    /* ATOM_BUCKET_HVML */ /*=*/ { 0, "ADD" },
    /* ATOM_BUCKET_HVML */       { 0, "CHAR" },
    /* ATOM_BUCKET_HVML */       { 0, "CLASS" },
    /* ATOM_BUCKET_HVML */       { 0, "DIV" },
    /* ATOM_BUCKET_HVML */       { 0, "FILTER" },
    /* ATOM_BUCKET_HVML */       { 0, "FORMULA" },
    /* ATOM_BUCKET_HVML */       { 0, "FUNC" },
    /* ATOM_BUCKET_HVML */       { 0, "KEY" },
    /* ATOM_BUCKET_HVML */       { 0, "MUL" },
    /* ATOM_BUCKET_HVML */       { 0, "OBJFORMULA" },
    /* ATOM_BUCKET_HVML */       { 0, "RANGE" },
    /* ATOM_BUCKET_HVML */       { 0, "SQL" },
    /* ATOM_BUCKET_HVML */       { 0, "SUB" },
    /* ATOM_BUCKET_HVML */       { 0, "TOKEN" },
    /* ATOM_BUCKET_HVML */       { 0, "TRAVEL" },
    /* ATOM_BUCKET_HVML */       { 0, "_grandparent" },
    /* ATOM_BUCKET_HVML */       { 0, "_last" },
    /* ATOM_BUCKET_HVML */       { 0, "_nexttolast" },
    /* ATOM_BUCKET_HVML */       { 0, "_parent" },
    /* ATOM_BUCKET_HVML */       { 0, "_root" },
    /* ATOM_BUCKET_HVML */       { 0, "_runner" },
    /* ATOM_BUCKET_HVML */       { 0, "_topmost" },
    /* ATOM_BUCKET_HVML */       { 0, "addPageGroups" },
    /* ATOM_BUCKET_HVML */       { 0, "against" },
    /* ATOM_BUCKET_HVML */       { 0, "append" },
    /* ATOM_BUCKET_HVML */       { 0, "as" },
    /* ATOM_BUCKET_HVML */       { 0, "asc" },
    /* ATOM_BUCKET_HVML */       { 0, "ascendingly" },
    /* ATOM_BUCKET_HVML */       { 0, "async" },
    /* ATOM_BUCKET_HVML */       { 0, "asynchronously" },
    /* ATOM_BUCKET_HVML */       { 0, "at" },
    /* ATOM_BUCKET_HVML */       { 0, "by" },
    /* ATOM_BUCKET_HVML */       { 0, "call" },
    /* ATOM_BUCKET_HVML */       { 0, "callMethod" },
    /* ATOM_BUCKET_HVML */       { 0, "case" },
    /* ATOM_BUCKET_HVML */       { 0, "caseinsensitively" },
    /* ATOM_BUCKET_HVML */       { 0, "caseless" },
    /* ATOM_BUCKET_HVML */       { 0, "casesensitively" },
    /* ATOM_BUCKET_HVML */       { 0, "clear" },
    /* ATOM_BUCKET_HVML */       { 0, "conc" },
    /* ATOM_BUCKET_HVML */       { 0, "concurrently" },
    /* ATOM_BUCKET_HVML */       { 0, "const" },
    /* ATOM_BUCKET_HVML */       { 0, "constantly" },
    /* ATOM_BUCKET_HVML */       { 0, "createPlainWindow" },
    /* ATOM_BUCKET_HVML */       { 0, "createWidget" },
    /* ATOM_BUCKET_HVML */       { 0, "createWorkspace" },
    /* ATOM_BUCKET_HVML */       { 0, "desc" },
    /* ATOM_BUCKET_HVML */       { 0, "descendingly" },
    /* ATOM_BUCKET_HVML */       { 0, "destroyPlainWindow" },
    /* ATOM_BUCKET_HVML */       { 0, "destroyWidget" },
    /* ATOM_BUCKET_HVML */       { 0, "destroyWorkspace" },
    /* ATOM_BUCKET_HVML */       { 0, "displace" },
    /* ATOM_BUCKET_HVML */       { 0, "endSession" },
    /* ATOM_BUCKET_HVML */       { 0, "erase" },
    /* ATOM_BUCKET_HVML */       { 0, "excl" },
    /* ATOM_BUCKET_HVML */       { 0, "exclusively" },
    /* ATOM_BUCKET_HVML */       { 0, "for" },
    /* ATOM_BUCKET_HVML */       { 0, "from" },
    /* ATOM_BUCKET_HVML */       { 0, "href" },
    /* ATOM_BUCKET_HVML */       { 0, "idd-by" },
    /* ATOM_BUCKET_HVML */       { 0, "in" },
    /* ATOM_BUCKET_HVML */       { 0, "individually" },
    /* ATOM_BUCKET_HVML */       { 0, "indv" },
    /* ATOM_BUCKET_HVML */       { 0, "insertAfter" },
    /* ATOM_BUCKET_HVML */       { 0, "insertBefore" },
    /* ATOM_BUCKET_HVML */       { 0, "intersect" },
    /* ATOM_BUCKET_HVML */       { 0, "load" },
    /* ATOM_BUCKET_HVML */       { 0, "merge" },
    /* ATOM_BUCKET_HVML */       { 0, "method" },
    /* ATOM_BUCKET_HVML */       { 0, "must-yield" },
    /* ATOM_BUCKET_HVML */       { 0, "name" },
    /* ATOM_BUCKET_HVML */       { 0, "no-return" },
    /* ATOM_BUCKET_HVML */       { 0, "noreturn" },
    /* ATOM_BUCKET_HVML */       { 0, "nose-to-tail" },
    /* ATOM_BUCKET_HVML */       { 0, "nosetotail" },
    /* ATOM_BUCKET_HVML */       { 0, "on" },
    /* ATOM_BUCKET_HVML */       { 0, "once" },
    /* ATOM_BUCKET_HVML */       { 0, "onlyif" },
    /* ATOM_BUCKET_HVML */       { 0, "onto" },
    /* ATOM_BUCKET_HVML */       { 0, "overwrite" },
    /* ATOM_BUCKET_HVML */       { 0, "param" },
    /* ATOM_BUCKET_HVML */       { 0, "prepend" },
    /* ATOM_BUCKET_HVML */       { 0, "raw" },
    /* ATOM_BUCKET_HVML */       { 0, "rel" },
    /* ATOM_BUCKET_HVML */       { 0, "remove" },
    /* ATOM_BUCKET_HVML */       { 0, "removePageGroup" },
    /* ATOM_BUCKET_HVML */       { 0, "resp" },
    /* ATOM_BUCKET_HVML */       { 0, "responsively" },
    /* ATOM_BUCKET_HVML */       { 0, "setPageGroups" },
    /* ATOM_BUCKET_HVML */       { 0, "silently" },
    /* ATOM_BUCKET_HVML */       { 0, "src" },
    /* ATOM_BUCKET_HVML */       { 0, "startSession" },
    /* ATOM_BUCKET_HVML */       { 0, "subtract" },
    /* ATOM_BUCKET_HVML */       { 0, "sync" },
    /* ATOM_BUCKET_HVML */       { 0, "synchronously" },
    /* ATOM_BUCKET_HVML */       { 0, "target" },
    /* ATOM_BUCKET_HVML */       { 0, "temp" },
    /* ATOM_BUCKET_HVML */       { 0, "template" },
    /* ATOM_BUCKET_HVML */       { 0, "temporarily" },
    /* ATOM_BUCKET_HVML */       { 0, "to" },
    /* ATOM_BUCKET_HVML */       { 0, "type" },
    /* ATOM_BUCKET_HVML */       { 0, "uniq" },
    /* ATOM_BUCKET_HVML */       { 0, "uniquely" },
    /* ATOM_BUCKET_HVML */       { 0, "unite" },
    /* ATOM_BUCKET_HVML */       { 0, "updatePlainWindow" },
    /* ATOM_BUCKET_HVML */       { 0, "updateWidget" },
    /* ATOM_BUCKET_HVML */       { 0, "updateWorkspace" },
    /* ATOM_BUCKET_HVML */       { 0, "via" },
    /* ATOM_BUCKET_HVML */       { 0, "while" },
    /* ATOM_BUCKET_HVML */       { 0, "wholly" },
    /* ATOM_BUCKET_HVML */       { 0, "with" },
    /* ATOM_BUCKET_HVML */       { 0, "within" },
    /* ATOM_BUCKET_HVML */       { 0, "writeBegin" },
    /* ATOM_BUCKET_HVML */       { 0, "writeEnd" },
    /* ATOM_BUCKET_HVML */       { 0, "writeMore" },
    /* ATOM_BUCKET_HVML */       { 0, "xor" },
    /* ATOM_BUCKET_MSG */ /*=*/ { 0, "async" },
    /* ATOM_BUCKET_MSG */       { 0, "attached" },
    /* ATOM_BUCKET_MSG */       { 0, "callState" },
    /* ATOM_BUCKET_MSG */       { 0, "change" },
    /* ATOM_BUCKET_MSG */       { 0, "click" },
    /* ATOM_BUCKET_MSG */       { 0, "close" },
    /* ATOM_BUCKET_MSG */       { 0, "corState" },
    /* ATOM_BUCKET_MSG */       { 0, "dblclick" },
    /* ATOM_BUCKET_MSG */       { 0, "detached" },
    /* ATOM_BUCKET_MSG */       { 0, "displaced" },
    /* ATOM_BUCKET_MSG */       { 0, "event" },
    /* ATOM_BUCKET_MSG */       { 0, "except" },
    /* ATOM_BUCKET_MSG */       { 0, "expired" },
    /* ATOM_BUCKET_MSG */       { 0, "fetcherState" },
    /* ATOM_BUCKET_MSG */       { 0, "idle" },
    /* ATOM_BUCKET_MSG */       { 0, "lastMsg" },
    /* ATOM_BUCKET_MSG */       { 0, "rdrState" },
    /* ATOM_BUCKET_MSG */       { 0, "readable" },
    /* ATOM_BUCKET_MSG */       { 0, "request" },
    /* ATOM_BUCKET_MSG */       { 0, "requestChan" },
    /* ATOM_BUCKET_MSG */       { 0, "response" },
    /* ATOM_BUCKET_MSG */       { 0, "sleep" },
    /* ATOM_BUCKET_MSG */       { 0, "subExit" },
    /* ATOM_BUCKET_MSG */       { 0, "writable" },
};

static int keywords_init_once(void)
{
    keywords_bucket_init(keywords, 0, 116, ATOM_BUCKET_HVML);
    keywords_bucket_init(keywords, 116, 140, ATOM_BUCKET_MSG);
    return 0;
}

struct pcmodule _module_keywords = {
    .id              = PURC_HAVE_UTILS,
    .module_inited   = 0,

    .init_once       = keywords_init_once,
    .init_instance   = NULL,
};

