/**
 * @file html_interface_res.h
 * @author 
 * @date 2021/07/02
 * @brief The hearder file for resource of html interface.
 *
 * Copyright (C) 2021 FMSoft <https://www.fmsoft.cn>
 *
 * This file is a part of PurC (short for Purring Cat), an HVML interpreter.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * The code is derived from Lexbor (<https://github.com/lexbor/lexbor>),
 * which is licensed under the Apache License, Version 2.0:
 *
 * Copyright (C) 2018 Alexander Borisov
 *
 * Author: Alexander Borisov <borisov@lexbor.com>
 */

/*
 * CAUTION:
 * This file generated by the script "tags.py"!
 * Do not change this file!
 */


#ifndef PCHTML_HTML_INTERFACE_RES_H
#define PCHTML_HTML_INTERFACE_RES_H

#endif /* PCHTML_HTML_INTERFACE_RES_H */

#ifdef PCHTML_TAG_CONST_VERSION
#ifndef PCHTML_TAG_CONST_VERSION_B8542F7FAD05D5F6ED2DE2DAA5F870AC
#error Mismatched tags version! See "lexbor/tag/const.h".
#endif /* PCHTML_TAG_CONST_VERSION_B8542F7FAD05D5F6ED2DE2DAA5F870AC */
#else
#error You need to include "lexbor/tag/const.h".
#endif /* PCHTML_TAG_CONST_VERSION */

#ifdef PCHTML_NS_CONST_VERSION
#ifndef PCHTML_NS_CONST_VERSION_203D1192AD2D6A84078C4ECF7E381FCB
#error Mismatched namespaces version! See "lexbor/ns/const.h".
#endif /* PCHTML_NS_CONST_VERSION_203D1192AD2D6A84078C4ECF7E381FCB */
#else
#error You need to include "lexbor/ns/const.h".
#endif /* PCHTML_NS_CONST_VERSION */

#include "private/dom.h"
#include "html/interfaces/document.h"
#include "html/interfaces/anchor_element.h"
#include "html/interfaces/area_element.h"
#include "html/interfaces/audio_element.h"
#include "html/interfaces/br_element.h"
#include "html/interfaces/base_element.h"
#include "html/interfaces/body_element.h"
#include "html/interfaces/button_element.h"
#include "html/interfaces/canvas_element.h"
#include "html/interfaces/d_list_element.h"
#include "html/interfaces/data_element.h"
#include "html/interfaces/data_list_element.h"
#include "html/interfaces/details_element.h"
#include "html/interfaces/dialog_element.h"
#include "html/interfaces/directory_element.h"
#include "html/interfaces/div_element.h"
#include "html/interfaces/element.h"
#include "html/interfaces/embed_element.h"
#include "html/interfaces/field_set_element.h"
#include "html/interfaces/font_element.h"
#include "html/interfaces/form_element.h"
#include "html/interfaces/frame_element.h"
#include "html/interfaces/frame_set_element.h"
#include "html/interfaces/hr_element.h"
#include "html/interfaces/head_element.h"
#include "html/interfaces/heading_element.h"
#include "html/interfaces/html_element.h"
#include "html/interfaces/iframe_element.h"
#include "html/interfaces/image_element.h"
#include "html/interfaces/input_element.h"
#include "html/interfaces/li_element.h"
#include "html/interfaces/label_element.h"
#include "html/interfaces/legend_element.h"
#include "html/interfaces/link_element.h"
#include "html/interfaces/map_element.h"
#include "html/interfaces/marquee_element.h"
#include "html/interfaces/media_element.h"
#include "html/interfaces/menu_element.h"
#include "html/interfaces/meta_element.h"
#include "html/interfaces/meter_element.h"
#include "html/interfaces/mod_element.h"
#include "html/interfaces/o_list_element.h"
#include "html/interfaces/object_element.h"
#include "html/interfaces/opt_group_element.h"
#include "html/interfaces/option_element.h"
#include "html/interfaces/output_element.h"
#include "html/interfaces/paragraph_element.h"
#include "html/interfaces/param_element.h"
#include "html/interfaces/picture_element.h"
#include "html/interfaces/pre_element.h"
#include "html/interfaces/progress_element.h"
#include "html/interfaces/quote_element.h"
#include "html/interfaces/script_element.h"
#include "html/interfaces/select_element.h"
#include "html/interfaces/slot_element.h"
#include "html/interfaces/source_element.h"
#include "html/interfaces/span_element.h"
#include "html/interfaces/style_element.h"
#include "html/interfaces/table_caption_element.h"
#include "html/interfaces/table_cell_element.h"
#include "html/interfaces/table_col_element.h"
#include "html/interfaces/table_element.h"
#include "html/interfaces/table_row_element.h"
#include "html/interfaces/table_section_element.h"
#include "html/interfaces/template_element.h"
#include "html/interfaces/text_area_element.h"
#include "html/interfaces/time_element.h"
#include "html/interfaces/title_element.h"
#include "html/interfaces/track_element.h"
#include "html/interfaces/u_list_element.h"
#include "html/interfaces/unknown_element.h"
#include "html/interfaces/video_element.h"
#include "html/interfaces/window.h"

#ifdef PCHTML_HTML_INTERFACE_RES_CONSTRUCTORS
#ifndef PCHTML_HTML_INTERFACE_RES_CONSTRUCTORS_ENABLED
#define PCHTML_HTML_INTERFACE_RES_CONSTRUCTORS_ENABLED
static  pcdom_interface_constructor_f pchtml_html_interface_res_constructors[PCHTML_TAG__LAST_ENTRY][PCHTML_NS__LAST_ENTRY] = 
{
    /* PCHTML_TAG__UNDEF */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG__END_OF_FILE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG__TEXT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_text_interface_create,
        (pcdom_interface_constructor_f) pcdom_text_interface_create,
        (pcdom_interface_constructor_f) pcdom_text_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG__DOCUMENT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_document_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG__EM_COMMENT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_comment_interface_create,
        (pcdom_interface_constructor_f) pcdom_comment_interface_create,
        (pcdom_interface_constructor_f) pcdom_comment_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG__EM_DOCTYPE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_document_type_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_A */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_anchor_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ABBR */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ACRONYM */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ADDRESS */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ALTGLYPH */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ALTGLYPHDEF */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ALTGLYPHITEM */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ANIMATECOLOR */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ANIMATEMOTION */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ANIMATETRANSFORM */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ANNOTATION_XML */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_APPLET */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_AREA */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_area_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ARTICLE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ASIDE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_AUDIO */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_audio_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_B */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_BASE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_base_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_BASEFONT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_BDI */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_BDO */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_BGSOUND */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_BIG */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_BLINK */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_BLOCKQUOTE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_quote_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_BODY */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_body_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_BR */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_br_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_BUTTON */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_button_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_CANVAS */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_canvas_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_CAPTION */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_table_caption_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_CENTER */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_CITE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_CLIPPATH */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_CODE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_COL */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_table_col_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_COLGROUP */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_table_col_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DATA */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_data_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DATALIST */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_data_list_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DD */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DEL */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_mod_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DESC */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DETAILS */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_details_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DFN */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DIALOG */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_dialog_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DIR */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_directory_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DIV */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_div_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DL */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_d_list_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_DT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_EM */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_EMBED */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_embed_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEBLEND */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FECOLORMATRIX */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FECOMPONENTTRANSFER */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FECOMPOSITE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FECONVOLVEMATRIX */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEDIFFUSELIGHTING */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEDISPLACEMENTMAP */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEDISTANTLIGHT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEDROPSHADOW */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEFLOOD */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEFUNCA */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEFUNCB */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEFUNCG */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEFUNCR */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEGAUSSIANBLUR */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEIMAGE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEMERGE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEMERGENODE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEMORPHOLOGY */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEOFFSET */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FEPOINTLIGHT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FESPECULARLIGHTING */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FESPOTLIGHT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FETILE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FETURBULENCE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FIELDSET */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_field_set_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FIGCAPTION */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FIGURE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FONT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_font_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FOOTER */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FOREIGNOBJECT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FORM */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_form_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FRAME */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_frame_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_FRAMESET */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_frame_set_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_GLYPHREF */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_H1 */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_heading_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_H2 */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_heading_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_H3 */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_heading_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_H4 */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_heading_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_H5 */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_heading_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_H6 */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_heading_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_HEAD */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_head_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_HEADER */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_HGROUP */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_HR */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_hr_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_HTML */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_I */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_IFRAME */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_iframe_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_IMAGE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_image_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_IMG */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_image_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_INPUT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_input_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_INS */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_mod_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_ISINDEX */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_KBD */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_KEYGEN */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_LABEL */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_label_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_LEGEND */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_legend_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_LI */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_li_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_LINEARGRADIENT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_LINK */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_link_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_LISTING */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_pre_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MAIN */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MALIGNMARK */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MAP */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_map_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MARK */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MARQUEE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_marquee_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MATH */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MENU */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_menu_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_META */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_meta_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_METER */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_meter_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MFENCED */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MGLYPH */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MI */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MN */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MO */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MS */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MTEXT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_MULTICOL */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_NAV */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_NEXTID */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_NOBR */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_NOEMBED */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_NOFRAMES */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_NOSCRIPT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_OBJECT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_object_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_OL */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_o_list_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_OPTGROUP */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_opt_group_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_OPTION */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_option_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_OUTPUT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_output_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_P */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_paragraph_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_PARAM */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_param_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_PATH */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_PICTURE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_picture_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_PLAINTEXT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_PRE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_pre_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_PROGRESS */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_progress_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_Q */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_quote_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_RADIALGRADIENT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_RB */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_RP */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_RT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_RTC */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_RUBY */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_S */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SAMP */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SCRIPT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_script_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SECTION */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SELECT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_select_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SLOT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_slot_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SMALL */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SOURCE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_source_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SPACER */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SPAN */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_span_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_STRIKE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_STRONG */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_STYLE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_style_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SUB */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SUMMARY */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SUP */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_SVG */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TABLE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_table_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TBODY */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_table_section_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TD */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_table_cell_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TEMPLATE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_template_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TEXTAREA */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_text_area_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TEXTPATH */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TFOOT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_table_section_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TH */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_table_cell_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_THEAD */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_table_section_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TIME */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_time_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TITLE */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_title_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TR */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_table_row_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TRACK */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_track_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_TT */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_U */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_UL */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_u_list_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_VAR */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_VIDEO */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_video_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_WBR */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    },
    /* PCHTML_TAG_XMP */
    {
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_unknown_element_interface_create,
        (pcdom_interface_constructor_f) pchtml_html_pre_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create,
        (pcdom_interface_constructor_f) pcdom_element_interface_create
    }
};
#endif /* PCHTML_HTML_INTERFACE_RES_CONSTRUCTORS_ENABLED */
#endif /* PCHTML_HTML_INTERFACE_RES_CONSTRUCTORS */

#ifdef PCHTML_HTML_INTERFACE_RES_DESTRUCTOR
#ifndef PCHTML_HTML_INTERFACE_RES_DESTRUCTOR_ENABLED
#define PCHTML_HTML_INTERFACE_RES_DESTRUCTOR_ENABLED
static  pcdom_interface_destructor_f pchtml_html_interface_res_destructor[PCHTML_TAG__LAST_ENTRY][PCHTML_NS__LAST_ENTRY] = 
{
    /* PCHTML_TAG__UNDEF */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG__END_OF_FILE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG__TEXT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_text_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_text_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_text_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG__DOCUMENT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_document_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG__EM_COMMENT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_comment_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_comment_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_comment_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG__EM_DOCTYPE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_document_type_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_A */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_anchor_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ABBR */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ACRONYM */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ADDRESS */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ALTGLYPH */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ALTGLYPHDEF */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ALTGLYPHITEM */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ANIMATECOLOR */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ANIMATEMOTION */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ANIMATETRANSFORM */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ANNOTATION_XML */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_APPLET */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_AREA */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_area_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ARTICLE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ASIDE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_AUDIO */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_audio_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_B */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_BASE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_base_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_BASEFONT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_BDI */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_BDO */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_BGSOUND */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_BIG */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_BLINK */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_BLOCKQUOTE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_quote_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_BODY */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_body_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_BR */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_br_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_BUTTON */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_button_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_CANVAS */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_canvas_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_CAPTION */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_table_caption_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_CENTER */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_CITE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_CLIPPATH */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_CODE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_COL */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_table_col_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_COLGROUP */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_table_col_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DATA */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_data_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DATALIST */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_data_list_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DD */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DEL */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_mod_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DESC */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DETAILS */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_details_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DFN */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DIALOG */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_dialog_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DIR */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_directory_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DIV */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_div_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DL */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_d_list_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_DT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_EM */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_EMBED */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_embed_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEBLEND */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FECOLORMATRIX */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FECOMPONENTTRANSFER */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FECOMPOSITE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FECONVOLVEMATRIX */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEDIFFUSELIGHTING */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEDISPLACEMENTMAP */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEDISTANTLIGHT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEDROPSHADOW */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEFLOOD */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEFUNCA */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEFUNCB */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEFUNCG */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEFUNCR */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEGAUSSIANBLUR */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEIMAGE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEMERGE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEMERGENODE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEMORPHOLOGY */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEOFFSET */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FEPOINTLIGHT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FESPECULARLIGHTING */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FESPOTLIGHT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FETILE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FETURBULENCE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FIELDSET */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_field_set_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FIGCAPTION */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FIGURE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FONT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_font_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FOOTER */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FOREIGNOBJECT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FORM */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_form_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FRAME */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_frame_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_FRAMESET */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_frame_set_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_GLYPHREF */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_H1 */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_heading_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_H2 */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_heading_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_H3 */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_heading_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_H4 */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_heading_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_H5 */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_heading_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_H6 */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_heading_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_HEAD */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_head_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_HEADER */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_HGROUP */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_HR */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_hr_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_HTML */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_I */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_IFRAME */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_iframe_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_IMAGE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_image_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_IMG */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_image_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_INPUT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_input_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_INS */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_mod_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_ISINDEX */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_KBD */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_KEYGEN */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_LABEL */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_label_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_LEGEND */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_legend_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_LI */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_li_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_LINEARGRADIENT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_LINK */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_link_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_LISTING */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_pre_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MAIN */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MALIGNMARK */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MAP */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_map_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MARK */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MARQUEE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_marquee_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MATH */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MENU */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_menu_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_META */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_meta_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_METER */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_meter_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MFENCED */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MGLYPH */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MI */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MN */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MO */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MS */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MTEXT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_MULTICOL */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_NAV */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_NEXTID */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_NOBR */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_NOEMBED */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_NOFRAMES */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_NOSCRIPT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_OBJECT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_object_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_OL */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_o_list_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_OPTGROUP */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_opt_group_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_OPTION */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_option_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_OUTPUT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_output_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_P */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_paragraph_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_PARAM */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_param_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_PATH */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_PICTURE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_picture_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_PLAINTEXT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_PRE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_pre_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_PROGRESS */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_progress_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_Q */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_quote_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_RADIALGRADIENT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_RB */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_RP */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_RT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_RTC */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_RUBY */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_S */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SAMP */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SCRIPT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_script_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SECTION */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SELECT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_select_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SLOT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_slot_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SMALL */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SOURCE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_source_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SPACER */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SPAN */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_span_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_STRIKE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_STRONG */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_STYLE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_style_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SUB */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SUMMARY */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SUP */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_SVG */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TABLE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_table_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TBODY */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_table_section_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TD */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_table_cell_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TEMPLATE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_template_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TEXTAREA */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_text_area_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TEXTPATH */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TFOOT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_table_section_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TH */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_table_cell_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_THEAD */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_table_section_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TIME */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_time_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TITLE */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_title_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TR */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_table_row_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TRACK */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_track_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_TT */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_U */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_UL */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_u_list_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_VAR */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_VIDEO */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_video_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_WBR */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    },
    /* PCHTML_TAG_XMP */
    {
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_unknown_element_interface_destroy,
        (pcdom_interface_destructor_f) pchtml_html_pre_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy,
        (pcdom_interface_destructor_f) pcdom_element_interface_destroy
    }
};
#endif /* PCHTML_HTML_INTERFACE_RES_DESTRUCTOR_ENABLED */
#endif /* PCHTML_HTML_INTERFACE_RES_DESTRUCTOR */
